# mod/entry.py
#
#

""" commands to enter data. """

from bot.object import Object
from bot.space import cfg, kernel

import bot

class Entry(Object):
    """ Data Entry class . """
    pass

class Tomorrow(Entry):
    """ a todo for tomorrow to be done. """
    pass

class Rss(Entry):
    """ a RSS entry """
    pass

class Todo(Entry):
    """ a todo entry """
    pass

class Shop(Entry):
    """ a shopping item for the wife to shop. """
    pass

class Log(Entry):
    """ a log entry to log what is happening on the day. """
    pass

def alias(event):
    """ key, value alias. """
    import bot.space
    try:
        cmnd, value = event._parsed.rest.split(" ", 1)
    except ValueError:
        event.reply('alias <cmnd> <aliased>')
        return
    bot.space.alias[cmnd] = value
    bot.space.alias.save()
    event.ok(cmnd)

def log(event):
    """ log some text. """
    if not event._parsed.rest:
        event.reply("log <item>")
        return
    o = Log()
    o.log = event._parsed.rest
    o.save()   
    event.ok(1)

def shop(event):
    """ add a shopitem to the shopping list. """
    if not event._parsed.rest:
        event.reply("shop <item>")
        return
    o = Shop()
    o.shop = event._parsed.rest
    o.save()
    event.ok(1)

def rss(event):
    """ add a rss url. """
    if not event._parsed.rest:
        event.reply("rss <item>")
        return
    o = Rss()
    o.rss = event._parsed.rest
    o.service = "rss"
    o.save()  
    event.ok(1)

def todo(event):
    """ log a todo item. """
    if not event._parsed.rest:
        event.reply("todo <item>")
        return
    o = Todo()
    o.todo = event._parsed.rest
    o.save()
    event.ok(1)

def tomorrow(event):
    """ show todo items for tomorrow. """
    if not event._parsed.rest:
        event.reply("tomorrow <item>")
        return
    o = Tomorrow()
    o.tomorrow = event.txt.replace("tomorrow", "").strip()
    o.save()
    event.ok(1)
