# mad/utils/file.py
#
#

""" file related functions. """

from bot.trace import get_exception
from bot.join import j

import logging
import shutil
import stat
import os

dirmask = 0o700
filemask = 0o600

def touch(fname):
    try:
        fd = os.open(fname, os.O_RDONLY | os.O_CREAT)
        os.close(fd)
    except TypeError:
        pass
    except Exception as ex:
        logging.error(get_exception())

def check_permissions(ddir, dirmask=dirmask, filemask=filemask):
    uid = os.getuid()
    gid = os.getgid()
    try:
        stats = os.stat(ddir)
    except FileNotFoundError:
        return
    except OSError:
        d, fn = os.path.split(ddir)
        cdir(d)
        stats = os.stat(d)
    if stats.st_uid != uid:
        os.chown(ddir, uid, gid)
    if os.path.isfile(ddir):
        mask = filemask
    else:
        mask = dirmask
    m = oct(stat.S_IMODE(stats.st_mode))
    if m != oct(mask):
        os.chmod(ddir, mask)

def cdir(path):
    res = "" 
    #if not path.endswith(os.sep):
    #    path += os.sep
    for p in path.split(os.sep):
        res += "%s%s" % (p, os.sep)
        padje = os.path.abspath(os.path.normpath(res))
        try:
            os.mkdir(padje)
        except (IsADirectoryError, NotADirectoryError, FileExistsError):
            pass
        except OSError as ex:
            logging.error(get_exception())
    return True

def high(target, file_name):
    highest = 0
    for i in os.listdir(target):
        if file_name in i:
            try:
                seqnr = i.split('.')[-1]
            except IndexError:
                continue  
            try:
                if int(seqnr) > highest:
                    highest = int(seqnr)
            except ValueError:
                pass
    return highest

def highest(target, filename):
    nr = high(target, filename)
    return "%s.%s" % (filename, nr+1)

def cpdir(target, destination):
    for fn in os.listdir(target):
        d = j(target, fn)
        t = j(destination, fn)
        if os.path.isdir(d):
            cpdir(d, t)
            continue
        try:
            shutil.copyfile(d, t)
        except:
            pass

def locatedir(path, match=""):
    for root, dirs, files in os.walk(path):
        for d in dirs:
            if root == path:
                continue
            if match and match not in d:
                continue
            yield root

def initdir(path):
    os.mkdir(path)
    os.mkdir(j(path, "runtime"))
    os.mkdir(j(path, "top"))
    os.mkdir(j(path, "cfg"))
     