# mad/utils/json.py
#
#

""" functions used to dump json. """

import string
import json

pure_types = [str, int, float, bool, None]
basic_types = [dict, list, str, int, float, bool, None]
nodict_types = [list, str, int, float, bool, None]
allowedchars = string.ascii_letters + string.digits + "_,-. \n" + string.punctuation
allowednamechars = string.ascii_letters + string.digits + '!.@'

def smooth(a):
    if type(a) not in basic_types:
        return repr(a)
    return a

def dumps(object, *args, **kwargs):
    kwargs["sort_keys"] = True
    return json.dumps(object, default=smooth, *args, **kwargs)

def loads(s, *args, **kwargs):
    return json.loads(s)

def dumped(o):
    from bot.object import Object
    if "items" not in dir(o):
        return o
    if type(o) == dict:
        o = Object(o)
    o._type = str(type(o))
    for k, v in o.items():
        if k == "_type":
            continue
        if type(v) in nodict_types:
            o[k] = v
        else:
            o[k] = dumped(v)
    return o
