# mad/misc.py
#
#

""" misc. helper functions. """

import _thread
import time
import re
import os

_starttime = time.time()

def perminute():
    print("yo!")

def exclude(name):
    from bot.space import cfg
    n = name.split(".")[-1]
    if n == "cli":
        return False
    if not cfg.all:
        if n in cfg.exclude.split(","):
            return True
        if n not in cfg.init.split(","):
            return True
    else:
        if n in cfg.exclude.split(","):
            return True
    return False

def include(name):
    from bot.space import cfg
    n = name.split(".")[-1]
    if n in cfg.exclude:
        return False
    return True

def fnn(object):
    fn = object.f_code.co_filename
    return fn.split(os.sep)[-1][:-3]

def fields(cfg):
    for object in cfg.values():
        for key in object:
            yield key

def matching(keys, value):
    for key in keys:
        if key in value:
            return True
    return False

def get_source(mod, package="."):
    import pkg_resources as p
    source = os.path.abspath(p.resource_filename(mod, package))
    return source

def copyright():
    return "Copyright 2016,2017 Bart Thate"

def locked(func, *args, **kwargs):

    lock = _thread.allocate_lock()

    def lockedfunc(*args, **kwargs):
        lock.acquire()
        res = None
        try:
            res = func(*args, **kwargs)
        finally:
            try:
                lock.release()
            except:
                pass
        return res
    return lockedfunc

def split_txt(what, l=450):
    z = ""
    what = str(what)
    for txt in what.split("\n"):
        if len(txt) < l: yield txt
        else:
            for y in txt.split():
                if len(y) + len(z) < l:
                    z += " " + y
                    continue
                yield z.strip()
                z = ""
    if z: yield z.strip()
         
def stripped(input):
    try:
        return str(input).split("/")[0]
    except:
        return str(input)

def userhost(input):
    try:
        return str(input).split("!")[-1]
    except:
        return str(input)

def feed(text):
    from bot.object import Object
    result = []
    chunks = text.split("\r\n")
    for chunk in chunks:
        object = Object().feed(chunk)
        result.append(object)
    return result

def run_sed(filename, sedstring):
    f = open(filename, 'r')
    tmp = filename + '.tmp'
    fout = open(tmp, 'w')
    if sedstring:
        char = "#"
        seds = sedstring.split(char)
        fr = seds[1]
        to = seds[2]
        for line in f:
            l = re.sub(fr, to, line)
            fout.write(l)
    else:
        for line in f:
            l = re.sub("\t", "    ", line.rstrip() + "\n")
            fout.write(l)
    fout.flush()
    fout.close()
    os.rename(tmp, filename)

headertxt = '''# this is an MADBOT file, %s
#
# the bot can edit this file !!

'''

reliq = """
for i in range(int(len(input)/16)):
txt = input[i*16:i*16+16]
try: data += crypt.decrypt(txt)
except Exception as ex: logging.error(get_exception()) ;  break
"""
