# mad/utils/name.py
#
#

""" name related functions, strip objectect names to be easily representable. """

import os

def name(object):
    txt = repr(object)[1:-1]
    return fromstring(txt)

def fromstring(txt):
    if " object " in txt:
        txt = txt.split(" object ")[0]
    elif " at " in txt:
        txt = txt.split(" at ")[0]
    elif "bound method" in txt:
        txt = txt.split("bound method")[1].split()[0]
    if " of " in txt:
        t1, t2 = txt.split(" of ")
        txt = t2.split(".")[-1] + "." + t1.split(".")[-1]
    elif " from " in txt:
        txt = txt.split(" from ")[0].split()[1][1:-1]
    if "," in txt:
        txt = txt.split(",")[0]
    txt = txt.replace("<", "")
    txt = txt.replace("<function ", "")
    txt = txt.replace("function ", "")
    txt = txt.replace("<bound method ", "")
    txt = txt.replace("bound method ", "")
    return txt.strip()

def pname(object):
    return repr(object)

def sname(object):
    return tname(object).split(".")[-1]

def tname(object):
    return name(object).split("(")[-1]

def n(object):
    return str(object.__class__).split()[-1].split(".")[-1][:-2].lower()

def pathname(p):
    from bot.space import cfg
    d = cfg.workdir.split(os.sep)[-1]
    return d + p.split(cfg.workdir)[-1]