# mad/utils/signature.py
#
#

""" signature related functions. """

import hashlib
import json

def signature(object): return str(hashlib.sha1(bytes(str(object), "utf-8")).hexdigest())

def make_signature(object):
    data = json.dumps(object, indent=4, ensure_ascii=True, sort_keys=True)
    return str(hashlib.sha1(bytes(str(data), "utf-8")).hexdigest())

def verify_signature(object, signature):
    signature2 = make_signature(object)
    return signature2 == signature
