# bot/space.py
#
#

""" Framework to program bot, JSON file backend, MIT license. """

__all__ = ["exceptions", "alias", "cfg", "fleet", "kernel", "runtime", "seen", "users"]

from bot.alias import Alias
from bot.db import Db
from bot.error import *
from bot.fleet import Fleet
from bot.kernel import Kernel
from bot.launch import Launcher
from bot.join import j
from bot.object import Config, Default, Object
from bot.register import Register
from bot.runtime import Runtime
from bot.seen import Seen
from bot.shell import reset
from bot.users import Users

#:
exceptions = []
#:
alias = Alias()
#:
db = Db()
#:
cfg = Config()
#:
fleet = Fleet()
#:
kernel = Kernel()
#:
launcher = Launcher()
#:
partyline = Register()
#:
runtime = Runtime()
#:
seen = Seen()
#:
users = Users()

def load():
    alias.load(j(cfg.workdir, "runtime", "alias"))
    alias.l = "cmnds"
    alias.v = "version"
    alias.f = "find"
    seen.load(j(cfg.workdir, "runtime", "seen"))
    users.load(j(cfg.workdir, "runtime", "users"))
