# mad/template.py
#
#

"""
    default cfg objects containing default values for various services and plugins.

"""

from bot.object import Object
from bot.join import j

import socket
import os

#:
xmpp = Object()
xmpp.user = "meds@localhost"
xmpp.server = "localhost"
xmpp.username = "meds"
xmpp.channel = "#meds"
xmpp.nick = "meds"
xmpp.cfg = "xmpp"
xmpp.port = 5222
xmpp.owner = ""
xmpp.openfire = False
xmpp.noresolver = True
xmpp.silent = False

#:
irc = Object()
irc.cfg = "irc"
irc.channel = "#madbot"
irc.encoding = "utf-8"
irc.nick = "madbot"
irc.ipv6 = False
irc.owner = ""
irc.port = 6667
irc.realname = "madbot"
irc.server = "localhost"
irc.servermodes = ""
irc.username = "madbot"
irc.ssl = False
irc.silent = False

#:
kernel = Object()
kernel.all = False
kernel.args = []
kernel.cfg = "kernel"
kernel.changed = False
kernel.automeet = True
kernel.banner = False
kernel.colors = False
kernel.exclude = "test,xmpp"
kernel.homedir = os.path.abspath(os.path.expanduser("~"))
kernel.hostname = "localhost"
kernel.homedirs = False
kernel.ignore = ["bot.xmpp"]
kernel.init = ""
kernel.license = False
kernel.local = True
kernel.loglevel = ""
kernel.owner = "root@shell"
kernel.mods = ""
kernel.needed = ["bot.clock"]
kernel.packages = ["bot"]
kernel.port = 10102
kernel.shell = False
kernel.scan = False
kernel.resume = False
kernel.reboot = False
kernel.txt = "Framework to program bot, JSON file backend, MIT license."
kernel.test = False
kernel.verbose = False
kernel.workdir = j(kernel.homedir, ".madbot")
kernel.workdirs = []
kernel.write = False

#:
udp = Object()
udp.cfg = "udp"
udp.host = "localhost"
udp.port = 5500
udp.password = "boh"
udp.seed = "blablablablablaz" # needs to be 16 chars wide
udp.server = udp.host
udp.owner = ""

#:
rest = Object()
rest.cfg = "rest"
rest.hostname = "localhost"
rest.port = 10102
rest.server = rest.hostname
rest.owner = ""

#:
stats = Object()
stats.cfg = "stats"
stats.showurl = True
stats.owner = ""

#:
rss = Object()
rss.cfg = "rss"
rss.save_list = []
rss.display_list = ["title", "link", "published"]
rss.descriptions = ["officiel", ]
rss.sleeptime = 600
rss.ignore = []
rss.dosave = []
rss.nosave = []
rss.showurl = False
rss.owner = ""

#:
cli = Object()
cli.welcome = "mogge!!"
cli.cfg = "cli"
cli.server = "localhost"
cli.owner = ""
cli.silent = False

#:
input = Object()
input.server = "localhost"
input.cfg = "input"
input.owner = "root@shell"
input.silent = True

#:
result = Object()
result.server = "localhost"
result.cfg = "input"
result.owner = "root@shell"

#:
testbot = Object()
testbot.server = "localhost"
testbot.cfg = "input"
testbot.owner = "root@shell"
testbot.channel = "#madbot"

#:
raw = Object()
raw.server = "localhost"
raw.cfg = "raw"
raw.owner = "root@shell"
raw.channel = "#madbot"

#:
bot = Object()
bot.server = "localhost"
bot.cfg = "bot"
bot.owner = "root@shell"
bot.channel = "#madbot"

#:
timer = Object()
timer.cfg = "timer"
timer.latest = 0

#:
default = Object()
default.cfg = "default"

#:
template = Object()
template.xmpp = xmpp
template.irc = irc
template.kernel = kernel
template.udp = udp
template.rest = rest
template.rss = rss
template.cli = cli
template.input = input
template.result = result
template.testbot = testbot
template.bot = bot
template.default = default
template.timer = timer
template.raw = raw
template.stats = stats
